ompi/mca/allocator/basic/allocator_basic.h File Reference.TH "ompi/mca/allocator/basic/allocator_basic.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/allocator/basic/allocator_basic.h \- A generic memory basic allocator. 
.SH SYNOPSIS
.br
.PP
\fC#include <stdlib.h>\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'mca/allocator/allocator.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_allocator_basic_segment_t \fBmca_allocator_basic_segment_t\fP"
.br
.ti -1c
.RI "typedef mca_allocator_basic_module_t \fBmca_allocator_basic_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_allocator_basic_component_open\fP (void)"
.br
.ti -1c
.RI "int \fBmca_allocator_basic_component_close\fP (void)"
.br
.ti -1c
.RI "\fBmca_allocator_base_module_t\fP * \fBmca_allocator_basic_component_init\fP (bool enable_mpi_threads, \fBmca_allocator_base_component_segment_alloc_fn_t\fP segment_alloc, \fBmca_allocator_base_component_segment_free_fn_t\fP segment_free, struct \fBmca_mpool_base_module_t\fP *module)"
.br
.RI "\fIThe function used to initialize the component. \fP"
.ti -1c
.RI "void * \fBmca_allocator_basic_alloc\fP (\fBmca_allocator_base_module_t\fP *mem, size_t size, size_t align, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIAccepts a request for memory in a specific region defined by the mca_allocator_basic_options_t struct and returns a pointer to memory in that region or NULL if there was an error. \fP"
.ti -1c
.RI "void * \fBmca_allocator_basic_realloc\fP (\fBmca_allocator_base_module_t\fP *mem, void *ptr, size_t size, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIAttempts to resize the passed region of memory into a larger or a smaller region. \fP"
.ti -1c
.RI "void \fBmca_allocator_basic_free\fP (\fBmca_allocator_base_module_t\fP *mem, void *ptr)"
.br
.RI "\fIFrees the passed region of memory. \fP"
.ti -1c
.RI "int \fBmca_allocator_basic_compact\fP (\fBmca_allocator_base_module_t\fP *mem)"
.br
.RI "\fIFrees all the memory from all the basics back to the system. \fP"
.ti -1c
.RI "int \fBmca_allocator_basic_finalize\fP (\fBmca_allocator_base_module_t\fP *mem)"
.br
.RI "\fICleanup all resources held by this allocator. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_COMP_EXPORT \fBmca_allocator_base_component_t\fP \fBmca_allocator_basic_component\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
A generic memory basic allocator. 


.SH "Function Documentation"
.PP 
.SS "void* mca_allocator_basic_alloc (\fBmca_allocator_base_module_t\fP * base, size_t size, size_t align, mca_mpool_base_registration_t ** registration)"
.PP
Accepts a request for memory in a specific region defined by the mca_allocator_basic_options_t struct and returns a pointer to memory in that region or NULL if there was an error. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIsize\fP The size of the requested area of memory
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIPointer\fP to the area of memory if the allocation was successful 
.br
\fINULL\fP if the allocation was unsuccessful 
.RE
.PP

.SS "int mca_allocator_basic_compact (\fBmca_allocator_base_module_t\fP * mem)"
.PP
Frees all the memory from all the basics back to the system. 
.PP
Note that this function only frees memory that was previously freed with \fBmca_allocator_basic_free()\fP.
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINone\fP .RE
.PP

.SS "int mca_allocator_basic_finalize (\fBmca_allocator_base_module_t\fP * base)"
.PP
Cleanup all resources held by this allocator. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINone\fP .RE
.PP

.SS "void mca_allocator_basic_free (\fBmca_allocator_base_module_t\fP * base, void * ptr)"
.PP
Frees the passed region of memory. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIptr\fP A pointer to the region of memory to be freed
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINone\fP .RE
.PP

.SS "void* mca_allocator_basic_realloc (\fBmca_allocator_base_module_t\fP * base, void * ptr, size_t size, mca_mpool_base_registration_t ** registration)"
.PP
Attempts to resize the passed region of memory into a larger or a smaller region. 
.PP
If it is unsuccessful, it will return NULL and the passed area of memory will be untouched.
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIsize\fP The size of the requested area of memory 
.br
\fIptr\fP A pointer to the region of memory to be resized
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIPointer\fP to the area of memory if the reallocation was successful 
.br
\fINULL\fP if the allocation was unsuccessful 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
